## iulib 0.4

=== SConstruct ===
# -*- Python -*-

# Copyright 2008 Deutsches Forschungszentrum fuer Kuenstliche Intelligenz 
# or its licensors, as applicable.
# 
# You may not use this file except under the terms of the accompanying license.
# 
# Licensed under the Apache License, Version 2.0 (the "License"); you
# may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# Project: iulib - the open source image understanding library
# File: SConstruct
# Purpose: building iulib
# Responsible: kofler
# Reviewer: 
# Primary Repository: http://iulib.googlecode.com/svn/trunk/
# Web Sites: www.iupr.org, www.dfki.de

# hints for make users
#
#  make all = scons
#   install = scons install
#     clean = scons -c
# uninstall = scons -c install

EnsureSConsVersion(0,97)

import glob,os,sys,string,re

### Options exposed via SCons
opts = Options('custom.py')
opts.Add('opt', 'Compiler flags for optimization/debugging', "-g -O3")
opts.Add('warn', 'Compiler flags for warnings', "-Wall -D__warn_unused_result__=__far__")
opts.Add('prefix', 'The installation root for iulib', "/usr/local")

### globals
env = Environment(options=opts, CXXFLAGS="${opt} ${warn}")
Help(opts.GenerateHelpText(env))
conf = Configure(env)
if "-DUNSAFE" in env["opt"]:
    print "WARNING: compile with -DUNSAFE or high optimization only for production use"
if re.search(r'-O[234]',env["opt"]):
    print "compiling with high optimization"
if not re.search(r'-O[234]',env["opt"]):
    print "compiling for development (slower but safer)"

### FIXME these libraries should be optional, and compilation should
### be conditional based on their presence

### check for required (dev-) libraries (automatically added to env LIBS)
missing = ""
if not conf.CheckLibWithHeader('png', 'png.h', 'C', 'png_byte;', 1):
    missing += " libpng12-dev"
if not conf.CheckLibWithHeader('jpeg', 'jconfig.h', 'C', 'jpeg_std_error();', 1):
    missing += " libjpeg62-dev"    
if not conf.CheckLibWithHeader('tiff', 'tiff.h', 'C', 'inflate();', 1):
   missing += " libtiff4-dev"

if missing:
    print "\nPlease install the following required libraries (or equivalent):"
    print missing
    print
    Exit(1)

### check for optional parts
have_vidio = conf.CheckCXXHeader("ffmpeg/avcodec.h") and \
             conf.CheckCXXHeader("ffmpeg/avformat.h")
have_v4l2 = conf.CheckHeader("linux/videodev2.h")
have_sdl = conf.CheckCXXHeader("SDL/SDL_gfxPrimitives.h") and \
           conf.CheckCXXHeader("SDL/SDL.h")

have_vidio = 0 # FIXME
have_v4l2 = 0 # FIXME
have_sdl = 1
conf.Finish()

### install folders
prefix = "${prefix}"
incdir_iulib = prefix+"/include/iulib"
incdir_colib = prefix+"/include/colib"
libdir = prefix+"/lib"
datadir = prefix+"/share/iulib"
bindir = prefix+"/bin"

### collect sources etc.
env.Prepend(CPPPATH=[".","colib","imglib","imgio","imgbits","utils","vidio"])

sources = glob.glob("imglib/img*.cc") 
sources += glob.glob("imgbits/img*.cc")
sources += """
    imgio/autoinvert.cc imgio/imgio.cc imgio/io_jpeg.cc
    imgio/io_pbm.cc imgio/io_png.cc imgio/io_tiff.cc
""".split()

if have_vidio:
    sources += glob.glob("vidio/vidio.cc")
if have_v4l2:
    sources += glob.glob("vidio/v4l2cap.cc")
if have_sdl:
    sources += ["utils/dgraphics.cc","utils/SDL_lines.cc"]
else:
    sources += ["utils/dgraphics_nosdl.cc"]

libiulib = env.StaticLibrary('libiulib.a',sources)

env.Append(LIBPATH=['.'])
progs = env.Clone()
progs.Append(LIBS=libiulib)
for file in glob.glob("commands/*.cc"):
    progs.Program(file[:-3],file)
if have_vidio:
    progs.Program("vidio/test-vidio","vidio/test-vidio.cc")
    progs.Append(LIBS=["avformat","avcodec"])
if 0 and have_v4l2:
    progs.Program("vidio/test-vidcap","vidio/test-vidcap.cc")

env.Install(libdir,libiulib)
for header in glob.glob("*/*.h"): 
    if "colib/" in header:
        env.Install(incdir_colib,header)
    else:
        env.Install(incdir_iulib,header)
env.Alias('install',[libdir,incdir_iulib,incdir_colib])

test_builder = Builder(action='$SOURCE&&touch $TARGET',
                  suffix = '.passed',
                  src_suffix = '')
progs.Append(BUILDERS={'Test':test_builder})

if True: #"test" in COMMAND_LINE_TARGETS:
    for file in glob.glob("*/test-*.cc") + glob.glob("*/*/test-*.cc"):
        if not file.startswith('vidio'):
            progs.Program(file[:-3],file)
            progs.Test(file[:-3])
            progs.Alias("test",file[:-3]+".passed")

## iulib 0.3

=== debian/changelog ===
iulib (0.3-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch to autoreconf (Closes: #818515).
  * Bump compat level to 9 and std-version to 3.9.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Apr 2016 11:02:55 +0200

iulib (0.3-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on libtiff-dev, not libtiff4-dev" (Closes: #736015)
  * Change B-D to libpng-dev (Closes: #662381)
  * Fix GCC-5 build failiure by removing default parameters. (Closes: #799574)

 -- Tobias Frost <tobi@debian.org>  Sat, 23 Jan 2016 18:32:44 +0100

iulib (0.3-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch to automake1.11. (Closes: #724394)

 -- Eric Dorland <eric@debian.org>  Sat, 08 Mar 2014 02:46:04 -0500

iulib (0.3-3) unstable; urgency=low

  * Honour CPPFLAGS from dpkg-buildflags.
  * Multi-archify:
    + Make libiulib0 and libulib-dev ‘Multi-Arch: same’.
    + Add ‘Pre-Depends: ${misc:Pre-Depends}’ to libiulib0.
    + Install shared libraries to /usr/lib/$(DEB_HOST_MULTIARCH) rather than
      /usr/lib.
    + Bump minimum required version of dpkg-dev to 1.16.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 29 Oct 2011 22:28:04 +0200

iulib (0.3-2) unstable; urgency=low

  * Acknowledge NMU. Thanks to Luc Claes for his work.
  * Replace build-dependency on libjpeg62-dev with libjpeg-dev
    (closes: #634033). Thanks to Bill Allombert for the bug report.
  * Stop build-depending on FFmpeg libraries (closes: #569582).
  * Switch to source format 3.0 (quilt).
    + Add debian/source/format.
    + Drop README.source.
    + Drop build-dependency on quilt.
    + Don't use ‘quilt’ dh addon.
    + Remove explicit calls to dh_quilt_*patch in debian/rules.
  * Add myself to uploaders.
  * Update watch file.
  * Move libiulib0 to section libs.
  * Bump build-dependency on debhelper to >= 7.0.50.
  * Make patch headers DEP-3 compliant.
  * Remove unused ‘destdir’ patch.
  * Bump standards version to 3.9.2 (no changes needed).
  * Drop DM-Upload-Allowed field, no longer needed.
  * Honour {C,CXX,LD}FLAGS from dpkg-buildflags.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 16 Jul 2011 15:41:06 +0200

iulib (0.3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't ship .la files (Closes: #621518).

 -- Luk Claes <luk@debian.org>  Sat, 18 Jun 2011 20:03:03 +0200

iulib (0.3-1) unstable; urgency=low

  * Initial release. (Closes: #508143)

 -- Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>  Wed, 06 May 2009 22:05:13 +0200

=== debian/control ===
Source: iulib
Section: graphics
Priority: optional
Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
Uploaders: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf, libpng-dev, libjpeg-dev, libtiff-dev, libsdl-gfx1.2-dev, libsdl-image1.2-dev, dpkg-dev (>= 1.16)
Standards-Version: 3.9.8
Homepage: http://code.google.com/p/iulib/

Package: libiulib0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library of image understanding-related algorithms
 Iulib provides basic image processing, mathematical morphology, and machine  
 learning algorithms.
 .
 Iulib implements easy-to-use image and video I/O functions, as well as a  
 large number of common image processing functions.
 .
 Design goals are high portability, easy-to-understand algorithms, no  
 reliance on STL, and using a minimal set of data structures. Almost all  
 interfaces are written in terms of just numbers and the simple narray array  
 class.

Package: libiulib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libiulib0 (= ${binary:Version})
Description: C++ library of image understanding-related algorithms -- development files
 Iulib provides basic image processing, mathematical morphology, and machine  
 learning algorithms.
 .
 Iulib implements easy-to-use image and video I/O functions, as well as a  
 large number of common image processing functions.
 .
 Design goals are high portability, easy-to-understand algorithms, no  
 reliance on STL, and using a minimal set of data structures. Almost all  
 interfaces are written in terms of just numbers and the simple narray array  
 class.
 .
 This package includes header files and static libraries needed to compile
 programs using libiulib

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with autoreconf

## iulib 0.4

=== debian/changelog ===
iulib (0.4-1) experimental; urgency=low

  * New upstream release.
    + Drop patches/ftbfs, applied upstream.
    + Build system uses now scons: drop patches/destdir; update
      patches/shared_library and debian/rules accordingly.
    + Fix SDL libraries detection (patches/sdl_detection).
    + Build-depend on ImageMagick.
    + Update and compact debian/copyright.
  * Add myself to uploaders.
  * Move libiulib0 to section libs.
  * Use source format 3.0 (quilt).
  * Bump standards version to 3.8.4 (no changes needed).
  * Add symbols file. Build-depend on dpkg-dev (>= 1.15.3~), as we
    are using symbol tags.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 10 Feb 2010 17:21:24 +0100

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,16 @@
 Priority: optional
 Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
 Uploaders: Jakub Wilk <jwilk@debian.org>
-Build-Depends: debhelper (>= 9), dh-autoreconf, libpng-dev, libjpeg-dev, libtiff-dev, libsdl-gfx1.2-dev, libsdl-image1.2-dev, dpkg-dev (>= 1.16)
-Standards-Version: 3.9.8
+Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~), scons,
+  libpng12-dev, libjpeg62-dev, libtiff4-dev, libavcodec-dev, libavformat-dev,
+  libsdl-gfx1.2-dev, libsdl-image1.2-dev, imagemagick
+Standards-Version: 3.8.4
+DM-Upload-Allowed: yes
 Homepage: http://code.google.com/p/iulib/
 
 Package: libiulib0
 Section: libs
 Architecture: any
-Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ library of image understanding-related algorithms
  Iulib provides basic image processing, mathematical morphology, and machine  
@@ -28,7 +29,6 @@
 Package: libiulib-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, libiulib0 (= ${binary:Version})
 Description: C++ library of image understanding-related algorithms -- development files
  Iulib provides basic image processing, mathematical morphology, and machine

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	rm -f configure configure.ac

override_dh_auto_clean:
	-scons -c

override_du_auto_build:
	scons prefix=/usr

override_dh_auto_install:
	scons prefix=$(CURDIR)/debian/tmp/usr/ install
	cd debian/tmp/usr/lib/ && ln libiulib.so libiulib.so.0

%:
	dh $@

=== debian/watch ===
version=3
http://code.google.com/p/iulib/downloads/list http://iulib.googlecode.com/files/iulib-(.*)\.ta?r?\.?gz

## iulib 0.4%2bis%2b0.3

=== debian/changelog ===
iulib (0.4+is+0.3-3ubuntu2) utopic; urgency=medium

  * Resynchronise with Debian.  Remaining changes:
    - Build-depend on libtiff-dev, instead of libtiff4-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 May 2014 10:53:27 +0100

iulib (0.4+is+0.3-3ubuntu1) trusty; urgency=low

  * Build depend on libtiff-dev, instead of libtiff4-dev

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Thu, 05 Dec 2013 22:52:31 +0000

iulib (0.4+is+0.3-3) precise; urgency=low

  * Fake sync with Debian unstable.

 -- Felix Geyer <debfx-pkg@fobos.de>  Tue, 22 Nov 2011 10:17:26 +0100

iulib (0.4+is+0.3-1ubuntu1) precise; urgency=low

  * Build-depend on libjpeg-dev rather than libjpeg62-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 21 Nov 2011 22:47:35 +0000

iulib (0.4+is+0.3-1build1) natty; urgency=low

  * No-change rebuild to pick up multiarch libraries.

 -- Andreas Moog <amoog@ubuntu.com>  Mon, 04 Apr 2011 06:03:48 +0200

iulib (0.4+is+0.3-1) maverick; urgency=low

  * Revert to 0.3-1 for maverick release so that ocropus (0.3) can be built.
    See LP Bug #500527 for details.

 -- Stefano Rivera <stefanor@ubuntu.com>  Sun, 26 Sep 2010 14:06:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: iulib
 Section: graphics
 Priority: optional
-Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
 Uploaders: Jakub Wilk <jwilk@debian.org>
-Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~), scons,
-  libpng12-dev, libjpeg62-dev, libtiff4-dev, libavcodec-dev, libavformat-dev,
-  libsdl-gfx1.2-dev, libsdl-image1.2-dev, imagemagick
-Standards-Version: 3.8.4
-DM-Upload-Allowed: yes
+Build-Depends: debhelper (>= 7.0.50~), autotools-dev, automake1.11, libtool (>= 2), libpng12-dev, libjpeg-dev, libtiff-dev, libsdl-gfx1.2-dev, libsdl-image1.2-dev, dpkg-dev (>= 1.16)
+Standards-Version: 3.9.2
 Homepage: http://code.google.com/p/iulib/
 
 Package: libiulib0
 Section: libs
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ library of image understanding-related algorithms
  Iulib provides basic image processing, mathematical morphology, and machine  
@@ -29,6 +29,7 @@
 Package: libiulib-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, libiulib0 (= ${binary:Version})
 Description: C++ library of image understanding-related algorithms -- development files
  Iulib provides basic image processing, mathematical morphology, and machine

## iulib 0.4+is+0.3

=== SConstruct ===
--- 
+++ 
@@ -36,18 +36,16 @@
 
 ### Options exposed via SCons
 opts = Options('custom.py')
-opts.Add('opt', 'Compiler flags for optimization/debugging', "-g -O3")
-opts.Add('warn', 'Compiler flags for warnings', "-Wall -D__warn_unused_result__=__far__")
+opts.Add('opt', 'Compiler flags for optimization/debugging', "-g")
+opts.Add('warn', 'Compiler flags for warnings', "-Wall")
 opts.Add('prefix', 'The installation root for iulib', "/usr/local")
 
 ### globals
 env = Environment(options=opts, CXXFLAGS="${opt} ${warn}")
 Help(opts.GenerateHelpText(env))
 conf = Configure(env)
-if "-DUNSAFE" in env["opt"]:
+if "-DUNSAFE" in env["opt"] or re.search(r'-O[234]',env["opt"]):
     print "WARNING: compile with -DUNSAFE or high optimization only for production use"
-if re.search(r'-O[234]',env["opt"]):
-    print "compiling with high optimization"
 if not re.search(r'-O[234]',env["opt"]):
     print "compiling for development (slower but safer)"
 
@@ -60,8 +58,8 @@
     missing += " libpng12-dev"
 if not conf.CheckLibWithHeader('jpeg', 'jconfig.h', 'C', 'jpeg_std_error();', 1):
     missing += " libjpeg62-dev"    
-if not conf.CheckLibWithHeader('tiff', 'tiff.h', 'C', 'inflate();', 1):
-   missing += " libtiff4-dev"
+# if not conf.CheckLibWithHeader('tiff', 'tiff.h', 'C', 'inflate();', 1):
+#    missing += " libtiff4-dev"
 
 if missing:
     print "\nPlease install the following required libraries (or equivalent):"
@@ -74,11 +72,7 @@
              conf.CheckCXXHeader("ffmpeg/avformat.h")
 have_v4l2 = conf.CheckHeader("linux/videodev2.h")
 have_sdl = conf.CheckCXXHeader("SDL/SDL_gfxPrimitives.h") and \
-           conf.CheckCXXHeader("SDL/SDL.h")
-
-have_vidio = 0 # FIXME
-have_v4l2 = 0 # FIXME
-have_sdl = 1
+           conf.CheckCXXHeader("SDL/SDL.h") and \
 conf.Finish()
 
 ### install folders
@@ -90,13 +84,13 @@
 bindir = prefix+"/bin"
 
 ### collect sources etc.
-env.Prepend(CPPPATH=[".","colib","imglib","imgio","imgbits","utils","vidio"])
+env.Prepend(CPPPATH=[".","colib","imglib","imgio","imgbits","utils"])
 
 sources = glob.glob("imglib/img*.cc") 
 sources += glob.glob("imgbits/img*.cc")
 sources += """
     imgio/autoinvert.cc imgio/imgio.cc imgio/io_jpeg.cc
-    imgio/io_pbm.cc imgio/io_png.cc imgio/io_tiff.cc
+    imgio/io_pbm.cc imgio/io_png.cc
 """.split()
 
 if have_vidio:
@@ -104,14 +98,14 @@
 if have_v4l2:
     sources += glob.glob("vidio/v4l2cap.cc")
 if have_sdl:
-    sources += ["utils/dgraphics.cc","utils/SDL_lines.cc"]
+    sources += ["utils/dgraphics.cc"]
 else:
     sources += ["utils/dgraphics_nosdl.cc"]
 
 libiulib = env.StaticLibrary('libiulib.a',sources)
 
 env.Append(LIBPATH=['.'])
-progs = env.Clone()
+progs = env.Copy()
 progs.Append(LIBS=libiulib)
 for file in glob.glob("commands/*.cc"):
     progs.Program(file[:-3],file)

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
 Uploaders: Jakub Wilk <jwilk@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, automake1.11, libtool (>= 2), libpng12-dev, libjpeg-dev, libtiff-dev, libsdl-gfx1.2-dev, libsdl-image1.2-dev, dpkg-dev (>= 1.16)
+Build-Depends: debhelper (>= 7.0.50~), autotools-dev, automake1.9, libtool (>= 2), libpng12-dev, libjpeg-dev, libtiff-dev, libsdl-gfx1.2-dev, libsdl-image1.2-dev, dpkg-dev (>= 1.16)
 Standards-Version: 3.9.2
 Homepage: http://code.google.com/p/iulib/

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	mv aclocal.m4 aclocal.m4.old
	mv configure configure.old
	mv Makefile.in Makefile.in.old
	cp /usr/share/libtool/config/ltmain.sh .
	aclocal
	autoconf
	automake --add-missing
	./configure \
		--prefix=/usr \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

clean:
	dh_testdir
	dh_auto_clean
	dh_clean config.guess config.sub ltmain.sh
	[ ! -f aclocal.m4.old ] || mv aclocal.m4.old aclocal.m4
	[ ! -f configure.old ] || mv configure.old configure
	[ ! -f Makefile.in.old ] || mv Makefile.in.old Makefile.in

=== debian/watch ===
version=3
http://code.google.com/p/iulib/downloads/list //iulib.googlecode.com/files/iulib-(.*)\.ta?r?\.?gz

## iulib 0.4.4+ds

=== SConstruct ===
--- 
+++ 
@@ -35,44 +35,56 @@
 import glob,os,sys,string,re
 
 ### Options exposed via SCons
-opts = Options('custom.py')
-opts.Add('opt', 'Compiler flags for optimization/debugging', "-g")
-opts.Add('warn', 'Compiler flags for warnings', "-Wall")
+opts = Variables('custom.py')
+opts.Add('opt', 'Compiler flags for optimization/debugging', "-g -O3 -fPIC")
+opts.Add('warn', 'Compiler flags for warnings', "-Wall -D__warn_unused_result__=__far__")
 opts.Add('prefix', 'The installation root for iulib', "/usr/local")
 
-### globals
-env = Environment(options=opts, CXXFLAGS="${opt} ${warn}")
+opts.Add(BoolVariable('sdl', "provide SDL-based graphics routines", "yes"))
+opts.Add(BoolVariable('vidio', "provide video I/O functionality", "no"))
+opts.Add(BoolVariable('v4l2', "provide v4l2 functionality", "no"))
+
+opts.Add(BoolVariable('test', "Run some tests after the build", "no"))
+# opts.Add(BoolVariable('style', 'Check style', "no"))
+
+env = Environment(options=opts, CXXFLAGS=["${opt}","${warn}"])
 Help(opts.GenerateHelpText(env))
+
 conf = Configure(env)
-if "-DUNSAFE" in env["opt"] or re.search(r'-O[234]',env["opt"]):
+if "-DUNSAFE" in env["opt"]:
     print "WARNING: compile with -DUNSAFE or high optimization only for production use"
-if not re.search(r'-O[234]',env["opt"]):
+
+if re.search(r'-O[234]',env["opt"]):
+    print "compiling with high optimization"
+else:
     print "compiling for development (slower but safer)"
 
-### FIXME these libraries should be optional, and compilation should
-### be conditional based on their presence
-
-### check for required (dev-) libraries (automatically added to env LIBS)
-missing = ""
-if not conf.CheckLibWithHeader('png', 'png.h', 'C', 'png_byte;', 1):
-    missing += " libpng12-dev"
-if not conf.CheckLibWithHeader('jpeg', 'jconfig.h', 'C', 'jpeg_std_error();', 1):
-    missing += " libjpeg62-dev"    
-# if not conf.CheckLibWithHeader('tiff', 'tiff.h', 'C', 'inflate();', 1):
-#    missing += " libtiff4-dev"
-
-if missing:
-    print "\nPlease install the following required libraries (or equivalent):"
-    print missing
-    print
-    Exit(1)
+assert conf.CheckLibWithHeader('png', 'png.h', 'C', 'png_byte;', 1),"please install: libpng12-dev"
+assert conf.CheckLibWithHeader('jpeg', 'jconfig.h', 'C', 'jpeg_std_error();', 1),"please install: libjpeg62-dev"    
+assert conf.CheckLibWithHeader('tiff', 'tiff.h', 'C', 'inflate();', 1), "please install: libtiff4-dev"
 
 ### check for optional parts
-have_vidio = conf.CheckCXXHeader("ffmpeg/avcodec.h") and \
-             conf.CheckCXXHeader("ffmpeg/avformat.h")
-have_v4l2 = conf.CheckHeader("linux/videodev2.h")
-have_sdl = conf.CheckCXXHeader("SDL/SDL_gfxPrimitives.h") and \
-           conf.CheckCXXHeader("SDL/SDL.h") and \
+
+if env["sdl"]:
+    have_sdl = conf.CheckCXXHeader("SDL/SDL_gfxPrimitives.h") and \
+               conf.CheckCXXHeader("SDL/SDL.h")
+    assert have_sdl,"SDL requested, but can't find it"
+else:
+    have_sdl = 0
+
+if env["vidio"]:
+    have_vidio = conf.CheckCXXHeader("libavcodec/avcodec.h") and \
+                 conf.CheckCXXHeader("libavformat/avformat.h")
+    assert have_vidio,"vidio requested, but can't find it"
+else:
+    have_vidio = 0
+
+if env["v4l2"]:
+    have_v4l2 = conf.CheckHeader("linux/videodev2.h")
+    assert have_v4l2,"v4l2 requested, but can't find it"
+else:
+    have_v4l2 = 0
+
 conf.Finish()
 
 ### install folders
@@ -84,28 +96,32 @@
 bindir = prefix+"/bin"
 
 ### collect sources etc.
-env.Prepend(CPPPATH=[".","colib","imglib","imgio","imgbits","utils"])
+env.Prepend(CPPPATH=[".","colib","imglib","imgio","imgbits","utils","components","vidio"])
 
 sources = glob.glob("imglib/img*.cc") 
 sources += glob.glob("imgbits/img*.cc")
 sources += """
     imgio/autoinvert.cc imgio/imgio.cc imgio/io_jpeg.cc
-    imgio/io_pbm.cc imgio/io_png.cc
+    imgio/io_pbm.cc imgio/io_png.cc imgio/io_tiff.cc
+    components/components.cc
 """.split()
 
 if have_vidio:
     sources += glob.glob("vidio/vidio.cc")
 if have_v4l2:
     sources += glob.glob("vidio/v4l2cap.cc")
+    env.Append(LIBS=["v4l2"])
 if have_sdl:
-    sources += ["utils/dgraphics.cc"]
+    sources += ["utils/dgraphics.cc","utils/SDL_lines.cc"]
+    env.Append(LIBS=["SDL","SDL_gfx","SDL_image"])
 else:
     sources += ["utils/dgraphics_nosdl.cc"]
 
-libiulib = env.StaticLibrary('libiulib.a',sources)
+libiulib = env.SharedLibrary('libiulib',sources)
 
+env.Append(CXXFLAGS=['-g','-fPIC'])
 env.Append(LIBPATH=['.'])
-progs = env.Copy()
+progs = env.Clone()
 progs.Append(LIBS=libiulib)
 for file in glob.glob("commands/*.cc"):
     progs.Program(file[:-3],file)
@@ -128,7 +144,7 @@
                   src_suffix = '')
 progs.Append(BUILDERS={'Test':test_builder})
 
-if True: #"test" in COMMAND_LINE_TARGETS:
+if env["test"]:
     for file in glob.glob("*/test-*.cc") + glob.glob("*/*/test-*.cc"):
         if not file.startswith('vidio'):
             progs.Program(file[:-3],file)

=== debian/changelog ===
iulib (0.4.4+ds-1) experimental; urgency=low
 
  * New upstream release:
    + Upstream is not providing tarballs, repackage source using Mercurial
      repositories (hence ‘+ds’ suffix in the version number).
    + Bump SOVERSION to 0d; explain in README.source that SONAME is
      Debian-specific.
    + Update years in debian/copyright.
    + Refresh patches.
  * Stop build-depending on ffmpeg libraries (closes: #569582).
  * Replace build-dependency on libjpeg62-dev with libjpeg-dev.
  * Add support for parallel builds.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 28 Apr 2010 00:24:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: iulib
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
+Maintainer: Jeffrey Ratcliffe <Jeffrey.Ratcliffe@gmail.com>
 Uploaders: Jakub Wilk <jwilk@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, automake1.9, libtool (>= 2), libpng12-dev, libjpeg-dev, libtiff-dev, libsdl-gfx1.2-dev, libsdl-image1.2-dev, dpkg-dev (>= 1.16)
-Standards-Version: 3.9.2
+Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~), scons,
+  libpng12-dev, libjpeg-dev, libtiff4-dev,
+  libsdl-gfx1.2-dev, libsdl-image1.2-dev, imagemagick
+Standards-Version: 3.8.4
+DM-Upload-Allowed: yes
 Homepage: http://code.google.com/p/iulib/
 
-Package: libiulib0
+Package: libiulib0d
 Section: libs
 Architecture: any
-Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ library of image understanding-related algorithms
  Iulib provides basic image processing, mathematical morphology, and machine  
@@ -29,8 +29,7 @@
 Package: libiulib-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libiulib0 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libiulib0d (= ${binary:Version})
 Description: C++ library of image understanding-related algorithms -- development files
  Iulib provides basic image processing, mathematical morphology, and machine  
  learning algorithms.

=== debian/rules ===
#!/usr/bin/make -f

SOVERSION = 0d
SOURCE_DIR = $(dir $(firstword $(MAKEFILE_LIST)))/..
UPSTREAM_VERSION = $(shell cd $(SOURCE_DIR) && dpkg-parsechangelog | sed -n -r -e '/^Version: ([0-9.]+).*/ { s//\1/; p; q; }')

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    N_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    SCONS_FLAGS += -j$(N_JOBS)
endif
SCONS = scons $(SCONS_FLAGS)

override_dh_auto_configure:
	rm -f configure configure.ac

override_dh_auto_clean:
	-$(SCONS) -c

override_dh_auto_build:
	$(SCONS) prefix=/usr soversion=$(SOVERSION)

override_dh_auto_install:
	$(SCONS) prefix=$(CURDIR)/debian/tmp/usr/ install soversion=$(SOVERSION)
	cd debian/tmp/usr/lib/ && ln libiulib.so libiulib.so.$(SOVERSION)

get-orig-source:
	sh $(SOURCE_DIR)/debian/get-orig-source.sh $(UPSTREAM_VERSION)

%:
	dh $@

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds// \
http://code.google.com/p/iulib/downloads/list http://iulib.googlecode.com/files/iulib-(.*)\.ta?r?\.?gz
